//ASK ACTIVE MATERIAL'S COLOR //ask ruby side for active color
function GetActiveColor() {sketchup.GetActive('get active');}

//RECIVE ACTIVE MATERIAL'S COLOR
function returncolor(h,s,v) {//Update sliders values with the recived hsl color from ruby side
	document.getElementById('myRange1').value = h;
	document.getElementById('myRange2').value = s;
	document.getElementById('myRange3').value = v;
	document.getElementById('valBox1').innerHTML = Math.round(h * 100) / 100;
	document.getElementById('valBox2').innerHTML = Math.round(s * 100) / 100;
	document.getElementById('valBox3').innerHTML = Math.round(v * 100) / 100;
	UpdateColors(h,s,v);
}



function MPal() {

	var rules = document.getElementsByName('color_rule');
	var C_Rule = 'none';

	for (i=0; i < rules.length; i++) {//Loop into all radioboxes
		if (rules[i].checked) {C_Rule = rules[i].value;}
	}


	//MAKE PALLETES
	switch (C_Rule) {

	case "shades"://Shades, tones & tints
		var pallete_name = document.getElementById('id1').value;
		var type = 'Shade';
		var main = document.getElementById('STTbox1').value; // <<< MAIN
		var c1 = document.getElementById('STTbox2').value;
		var c2 = document.getElementById('STTbox3').value;
		var c3 = document.getElementById('STTbox4').value;
		var c4 = document.getElementById('STTbox5').value;
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'mono'://Monochromatic
		var pallete_name = document.getElementById('id1').value;
		var type = 'Mono';
		var main = document.getElementById('Mbox1').value; // <<< MAIN
		var c1 = document.getElementById('Mbox2').value;
		var c2 = document.getElementById('Mbox3').value;
		var c3 = document.getElementById('Mbox4').value;
		var c4 = document.getElementById('Mbox5').value;
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'anal'://Analogous
		var pallete_name = document.getElementById('id1').value;
		var type = 'Ana';
		var c1 = document.getElementById('Abox1').value;
		var c2 = document.getElementById('Abox2').value;
		var main = document.getElementById('Abox3').value; // <<< MAIN
		var c3 = document.getElementById('Abox4').value;
		var c4 = document.getElementById('Abox5').value;
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'compl'://Complementary
		var pallete_name = document.getElementById('id1').value;
		var type = 'Comp';
		var main = document.getElementById('Cbox1').value; // <<< MAIN
		var c1 = document.getElementById('Cbox2').value;
		var c2 = 'n/a';
		var c3 = 'n/a';
		var c4 = 'n/a';
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'split'://Split complementary
		var pallete_name = document.getElementById('id1').value;
		var type = 'Split comp';
		var main = document.getElementById('Sbox1').value; // <<< MAIN
		var c1 = document.getElementById('Sbox2').value;
		var c2 = document.getElementById('Sbox3').value;
		var c3 = 'n/a';
		var c4 = 'n/a';
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'tri'://Triadic
		var pallete_name = document.getElementById('id1').value;
		var type = 'Triad';
		var main = document.getElementById('Tbox1').value; // <<< MAIN
		var c1 = document.getElementById('Tbox2').value;
		var c2 = document.getElementById('Tbox3').value;
		var c3 = 'n/a';
		var c4 = 'n/a';
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'square'://Tetradic squ
		var pallete_name = document.getElementById('id1').value;
		var type = 'Tetra squ';
		var main = document.getElementById('TSbox1').value; // <<< MAIN
		var c1 = document.getElementById('TSbox2').value;
		var c2 = document.getElementById('TSbox3').value;
		var c3 = document.getElementById('TSbox4').value;
		var c4 = 'n/a';
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	case 'rect'://Tetradic rec
		var pallete_name = document.getElementById('id1').value;
		var type = 'Tetra rec';
		var main = document.getElementById('TRbox1').value; // <<< MAIN
		var c1 = document.getElementById('TRbox2').value;
		var c2 = document.getElementById('TRbox3').value;
		var c3 = document.getElementById('TRbox4').value;
		var c4 = 'n/a';
		sketchup.getUserInput(pallete_name, type, main, c1, c2, c3, c4);
	break;

	default:
		sketchup.PrintText('Pallete maker error: color rule not identifyed.');
	}

return
}


//SLIDERS
function HueSlider(newVal) {
document.getElementById('valBox1').innerHTML=newVal;
UpdateColors(newVal, document.getElementById('valBox2').innerHTML, document.getElementById('valBox3').innerHTML);
}

function SatSlider(newVal) {
document.getElementById('valBox2').innerHTML=newVal;
UpdateColors(document.getElementById('valBox1').innerHTML, newVal, document.getElementById('valBox3').innerHTML);
}

function ValSlider(newVal) {
document.getElementById('valBox3').innerHTML=newVal;
UpdateColors(document.getElementById('valBox1').innerHTML, document.getElementById('valBox2').innerHTML, newVal);
}


//UPDATE COLOR
function UpdateColors(h,s,v) {

	//Main boxes
	var MainColor = HSV2HEX(h,s,v);
	document.getElementById('MainColorBox').value = MainColor;
	document.getElementById('STTbox1').value = MainColor;
	document.getElementById('Mbox1').value = MainColor;
	document.getElementById('Abox3').value = MainColor;
	document.getElementById('Cbox1').value = MainColor;
	document.getElementById('Sbox1').value = MainColor;
	document.getElementById('Tbox1').value = MainColor;
	document.getElementById('TSbox1').value = MainColor;
	document.getElementById('TRbox1').value = MainColor;
	
	//Shades, tones & tints - sould saturation be a fixed num like 50%? not sure
	document.getElementById('STTbox2').value = HSV2HEX(h,s,90.0);
	document.getElementById('STTbox3').value = HSV2HEX(h,s,70.0);
	document.getElementById('STTbox4').value = HSV2HEX(h,s,50.0);
	document.getElementById('STTbox5').value = HSV2HEX(h,s,30.0);

	//Monochromatic
	document.getElementById('Mbox2').value = HSV2HEX(h,90.0,v);
	document.getElementById('Mbox3').value = HSV2HEX(h,70.0,v);
	document.getElementById('Mbox4').value = HSV2HEX(h,50.0,v);
	document.getElementById('Mbox5').value = HSV2HEX(h,30.0,v);

	//Analogous
	let hue_step = 30.0;
	let h1 = (h*1.0)-(2*hue_step);
	let h2 = (h*1.0)-(1*hue_step);
	let h4 = (h*1.0)+(1*hue_step);
	let h5 = (h*1.0)+(2*hue_step);
	if (h1<=0) {h1 = 360.0+h1}
	if (h2<=0) {h2 = 360.0+h2}
	document.getElementById('Abox1').value = HSV2HEX(h1,s,v);
	document.getElementById('Abox2').value = HSV2HEX(h2,s,v);
	document.getElementById('Abox4').value = HSV2HEX(h4,s,v);
	document.getElementById('Abox5').value = HSV2HEX(h5,s,v);

	//Complementary
	document.getElementById('Cbox2').value = HSV2HEX((h*1.0)+180.0,s,v);

	//Split complementary
	document.getElementById('Sbox2').value = HSV2HEX((h*1.0)+150.0,s,v);
	document.getElementById('Sbox3').value = HSV2HEX((h*1.0)+210.0,s,v);

	//Triadic
	document.getElementById('Tbox2').value = HSV2HEX((h*1.0)+120.0,s,v);
	document.getElementById('Tbox3').value = HSV2HEX((h*1.0)+240.0,s,v);

	//Tetradic squ
	document.getElementById('TSbox2').value = HSV2HEX((h*1.0)+90.0,s,v);
	document.getElementById('TSbox3').value = HSV2HEX((h*1.0)+180.0,s,v);
	document.getElementById('TSbox4').value = HSV2HEX((h*1.0)+270.0,s,v);

	//Tetradic rec
	document.getElementById('TRbox2').value = HSV2HEX((h*1.0)+150.0,s,v);
	document.getElementById('TRbox3').value = HSV2HEX((h*1.0)+300.0,s,v);
	document.getElementById('TRbox4').value = HSV2HEX((h*1.0)+330.0,s,v);
}


//Color space conversion (HSV/HSB to HEX (old RGB))
function HSV2HEX(h,s,v){
	// Must be fractions of 1
	h /= 360.0;
	s /= 100.0;
	v /= 100.0;

	var r, g, b, i, f, p, q, t, hex;

	i = Math.floor(h * 6);
	f = h * 6 - i;
	p = v * (1 - s);
	q = v * (1 - f * s);
	t = v * (1 - (1 - f) * s);

	switch (i % 6) {
		case 0: r = v, g = t, b = p; break;
		case 1: r = q, g = v, b = p; break;
		case 2: r = p, g = v, b = t; break;
		case 3: r = p, g = q, b = v; break;
		case 4: r = t, g = p, b = v; break;
		case 5: r = v, g = p, b = q; break;
	}

	r = Math.round(r * 255.0);
	g = Math.round(g * 255.0);
	b = Math.round(b * 255.0);

	//Convert RGB to HEX
	r = r.toString(16);
	g = g.toString(16);
	b = b.toString(16);

	if (r.length == 1) {r = '0' + r;}
	if (g.length == 1) {g = '0' + g;}
	if (b.length == 1) {b = '0' + b;}

	hex = '#' + r + g + b;
	console.log(hex);
	return hex;
}
//----------------------------------------------------



//IMPORT SKM
function Import_skm() {sketchup.Import_skm();}

//REPLACE TEXTURES
function Replace_tex() {sketchup.Replace_tex();}

//PURGE UNUSED MATERIALS
function Purge_un() {sketchup.Purge_un();}

//DELETE ALL MATERIAS IN SCENE
function Del_all() {sketchup.Del_all();}