=begin
#-------------------------------
Author: Tax, 2022
Description: Delete selected faces only, leaving edges and other objetcs.
#-------------------------------
=end


#-------------------------------------------------------------------------------
module Taxsola
	module Tax_Engineering

		def self.del_faces_dialog
			@Model = Sketchup.active_model
			@Selection = @Model.selection.to_a
			@Faces = @Selection.grep(Sketchup::Face)

			Sketchup.active_model.start_operation('Del faces', true)
				@Counter = 0
				@Faces.each do |face|
					face.erase!
					@Counter += 1
				end
			Sketchup.active_model.commit_operation

			@msg = @Counter.to_s + " faces deleted."
			Taxsola.soundeffect(1) #0: Installation | 1: Success | 2: Notification
		end

	end
end